#!/usr/bin/perl

#┌─────────────────────────────────
#│ WEB MART : check.cgi - 2021/04/25
#│ copyright (c) kentweb, 1997-2021
#│ https://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Net Shop v1.1 : check.cgi - 2022/11/21
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 設定データ認識
require "./init.cgi";
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
<li>Perlバージョン : $]
EOM

# ディレクトリ
my %dir = (
	$cf{datadir}       => 'データディレクトリ',
	"$cf{datadir}/log" => 'ログディレクトリ',
	"$cf{datadir}/ses" => 'セッションディレクトリ',
	"$cf{datadir}/pwd" => '管理パスワードディレクトリ',
	"$cf{datadir}/detail" => '商品詳細情報ディレクトリ',
	$cf{imgdir}        => '画像ディレクトリ',
	$cf{cmnurl}        => '共用ディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# データファイル
my %log = (
	"$cf{datadir}/law.dat" => '特商法ファイル',
	"$cf{datadir}/shop.dat" => '商品データ',
	"$cf{datadir}/pass.dat" => '管理パスワード',
	"$cf{datadir}/rtax.dat"  => '軽減税率ファイル',
	"$cf{datadir}/num.dat"  => '注文番号ファイル',
	"$cf{datadir}/ses.dat" => 'セッションデータ',
	"$cf{datadir}/stock.dat" => '在庫ファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# テンプレート
for (qw(top shop addr conf contact delivery detail error law find paycheck policy prog-1 prog-2 prog-3 prog-3p prog-4 prog-4p purchase send send-bank send-credit send-conv)) {
	if (-f "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

for (qw(order reply)) {
	if (-f "$cf{tmpldir}/$_.txt") {
		print "<li>テンプレート( $_.txt ) : OK\n";
	} else {
		print "<li>テンプレート( $_.txt ) : NG\n";
	}
}

# sendmailパス
if (-e $cf{sendmail}) {
	print "<li>sendmailパス : OK\n";
} else {
	print "<li>sendmailパス : NG\n";
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM
exit;

